﻿Imports Telerik.WinControls.UI

Public Class CustomRadMultiColumnComboBoxElement
    Inherits RadMultiColumnComboBoxElement
    Public Sub New()
        Me.AutoFilter = True
    End Sub

    Protected Overrides ReadOnly Property ThemeEffectiveType() As Type
        Get
            Return GetType(RadMultiColumnComboBoxElement)
        End Get
    End Property

    Public Overrides Sub ProcessReturnKey(e As System.Windows.Forms.KeyEventArgs)
        Dim text As String = Me.Text

        If Not String.IsNullOrEmpty(text) Then
            Dim newCurrentRow As GridViewRowInfo = TryCast(Me.FindItemExact(text), GridViewRowInfo)

            If newCurrentRow Is Nothing Then
                Me.AddTextAsRow(text)
            End If
        End If

        MyBase.ProcessReturnKey(e)
    End Sub

    Public Overrides Property Value() As Object
        Get
            Me.AddTextAsRow(Me.Text)
            Return MyBase.Value
        End Get
        Set(value As Object)
            MyBase.Value = value
        End Set
    End Property

    Private id As Integer = 4
    Private Sub AddTextAsRow(text__1 As String)
        Dim isContained As Boolean = False

        For Each item In Me.EditorControl.Rows
            If item.Cells(1).Value IsNot Nothing AndAlso DirectCast(item.Cells(1).Value, String) = Text Then
                isContained = True
            End If
        Next
        If Not isContained Then
            Me.EditorControl.Rows.Add(id, text__1)
            id += 1
        End If

    End Sub

End Class
