﻿Imports Telerik.WinControls.Data
Imports Telerik.WinControls.UI
Imports Telerik.WinControls

Partial Public Class Form1
    Inherits Form
    Public Sub New()
        InitializeComponent()

        AddHandler Me.RadGridView1.CellEditorInitialized, AddressOf radGridView1_CellEditorInitialized
        AddHandler Me.RadGridView1.EditorRequired, AddressOf radGridView1_EditorRequired
    End Sub

    Private Sub radGridView1_EditorRequired(sender As Object, e As EditorRequiredEventArgs)
        If e.EditorType = GetType(RadMultiColumnComboBoxElement) Then
            e.EditorType = GetType(CustomRadMultiColumnComboBoxElement)
        End If
    End Sub

    Private Sub radGridView1_CellEditorInitialized(sender As Object, e As GridViewCellEventArgs)
        Dim mccbEditor As RadMultiColumnComboBoxElement = TryCast(e.ActiveEditor, RadMultiColumnComboBoxElement)

        If mccbEditor IsNot Nothing Then
            Dim descriptor As New FilterDescriptor("Country", FilterOperator.StartsWith, Nothing)
            mccbEditor.EditorControl.FilterDescriptors.Add(descriptor)
        End If
    End Sub

    Protected Overrides Sub OnLoad(e As EventArgs)
        MyBase.OnLoad(e)

        Dim userTable As New DataTable("users")
        userTable.Columns.Add("UserID", GetType(Integer))
        userTable.Columns.Add("User", GetType(String))
        userTable.Columns.Add("CountryID", GetType(Integer))

        userTable.Rows.Add(1, "root", 1)
        userTable.Rows.Add(2, "admin", 1)
        userTable.Rows.Add(3, "jack", 2)
        userTable.Rows.Add(4, "guest", 2)
        userTable.Rows.Add(5, "sysadmin", 3)
        userTable.Rows.Add(6, "netadmin", 3)

        Me.RadGridView1.DataSource = userTable
        Me.RadGridView1.Columns.Remove("CountryID")

        Dim countryTable As New DataTable("countries")
        countryTable.Columns.Add("ID", GetType(Integer))
        countryTable.Columns.Add("Country", GetType(String))

        countryTable.Rows.Add(1, "USA")
        countryTable.Rows.Add(2, "Argentina")
        countryTable.Rows.Add(3, "Spain")


        Dim mccbColumn As New GridViewMultiComboBoxColumn("CountryID", "CountryID")
        mccbColumn.ValueMember = "ID"
        mccbColumn.DisplayMember = "Country"
        mccbColumn.DataSource = countryTable
        mccbColumn.DropDownStyle = RadDropDownStyle.DropDown
        Me.RadGridView1.Columns.Add(mccbColumn)
    End Sub
End Class